#ifndef PROGRESS_BAR_H_
#define PROGRESS_BAR_H_

#include <stdio.h>
#include <stdint.h>
#include <pthread.h>

#define PROGRESS_BAR_LENGTH 50

size_t progress_last_printed_count = 0;
size_t progress_count = 0;
pthread_mutex_t progress_mutex = PTHREAD_MUTEX_INITIALIZER;

void progress_bar_inc(void)
{
  pthread_mutex_lock(&progress_mutex);

  progress_count++;
  size_t filled_length = (PROGRESS_BAR_LENGTH*progress_count)/PROGRESS_BAR_TOTAL;
  size_t empty_length = PROGRESS_BAR_LENGTH - filled_length;

  printf("\r[");
  for (size_t i = 0; i < filled_length; i++) printf("=");
  for (size_t i = 0; i < empty_length; i++)  printf(" ");

  size_t percent = (100 * progress_count) / PROGRESS_BAR_TOTAL;
  if (percent == 100) printf("] %3zu%%\n", percent);
  else printf("] %3zu%%", percent);

  progress_last_printed_count = progress_count;

  fflush(stdout);
  pthread_mutex_unlock(&progress_mutex);
}

#endif // PROGRESS_BAR_H_
